import { EmptyArrayScalar, EmptyObjectScalar } from "./object-graph";
export interface PropertyInfo {
    name: string;
    descriptor: PropertyDescriptor;
    owner: object;
    objectDepth: number;
    treeDepth: number;
}
export interface GraphBuilderRules {
    maxDepth: number;
    maxObjectLength: number;
    resolveGetters: boolean;
    propertyFilter: (info: PropertyInfo) => boolean;
    isPrototypeExplorable: (proto: any) => boolean;
    getConstructor(obj: any): Function;
}
export declare class YamprintGraphBuilder {
    private _rules;
    private _knownNodes;
    private _currentDepth;
    constructor(_rules: GraphBuilderRules);
    /**
     * Takes an object and tries to identify it as a scalar. Returns a `Node` (could be a literal) if it was successful, or `null` if not.
     *
     * If you want to add more scalar types, you should do it here.
     * @param value
     * @returns {Node}
     * @private
     */
    protected _tryBuildScalar(value: any): any;
    protected _readObjectProprties(instance: object): EmptyObjectScalar;
    protected _readArray(value: Array<any>): EmptyArrayScalar;
    protected _toGraph(instance: any): any;
    toGraph(instance: any): any;
}
