"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class IndentedWriter {
    constructor(_indentStr) {
        this._indentStr = _indentStr;
        this._inner = "";
        this._depth = 0;
        this._needsIndent = false;
    }
    write(str) {
        if (this._needsIndent) {
            str = `\n${this._indentStr.repeat(this._depth)}${str}`;
            this._needsIndent = false;
        }
        this._inner += str;
    }
    writeLine(line) {
        let str = line || "";
        this.write(str);
        this._needsIndent = true;
    }
    indent(n) {
        this._depth += n;
    }
    output() {
        return this._inner;
    }
    clear() {
        this._inner = "";
        this._depth = 0;
        this._needsIndent = false;
    }
}
exports.IndentedWriter = IndentedWriter;
//# sourceMappingURL=indented-writer.js.map