"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class NodeBase {
    withMetadata(metadata) {
        this.metadata = metadata;
        return this;
    }
}
exports.NodeBase = NodeBase;
class PropertyItem {
    constructor(name, value) {
        this.name = name;
        this.value = value;
    }
}
exports.PropertyItem = PropertyItem;
class SparseArrayNode extends NodeBase {
    constructor(items) {
        super();
        this.items = items;
    }
}
exports.SparseArrayNode = SparseArrayNode;
class ArrayNode extends NodeBase {
    constructor(items) {
        super();
        this.items = items;
    }
}
exports.ArrayNode = ArrayNode;
class ObjectNode extends NodeBase {
    constructor(ctor, properties) {
        super();
        this.ctor = ctor;
        this.properties = properties;
    }
}
exports.ObjectNode = ObjectNode;
class TextBlockScalar extends NodeBase {
    constructor(lines) {
        super();
        this.lines = lines;
    }
}
exports.TextBlockScalar = TextBlockScalar;
class EmptyObjectScalar extends NodeBase {
    constructor(ctor) {
        super();
        this.ctor = ctor;
    }
}
exports.EmptyObjectScalar = EmptyObjectScalar;
class CircularReferenceScalar extends NodeBase {
}
exports.CircularReferenceScalar = CircularReferenceScalar;
class EmptyArrayScalar extends NodeBase {
}
exports.EmptyArrayScalar = EmptyArrayScalar;
class UnresolvedGetterScalar extends NodeBase {
    constructor() {
        super();
    }
}
exports.UnresolvedGetterScalar = UnresolvedGetterScalar;
class BinaryScalar extends NodeBase {
    constructor(name, size) {
        super();
        this.name = name;
        this.size = size;
    }
}
exports.BinaryScalar = BinaryScalar;
class ThrewErrorScalar extends NodeBase {
    constructor(error) {
        super();
        this.error = error;
    }
}
exports.ThrewErrorScalar = ThrewErrorScalar;
class DepthExceededScalar extends NodeBase {
    constructor(error) {
        super();
        this.error = error;
    }
}
exports.DepthExceededScalar = DepthExceededScalar;
//# sourceMappingURL=object-graph.js.map