import { BinaryScalar, TextBlockScalar } from "./object-graph";
export interface FormatSpecifier {
    propertyKey: (key: string) => string;
    constructorTag: (ctor: string) => string;
    arrayPrefix: string;
    indent: string;
    threwAlert: (error: any) => string;
    sparseArrayIndex: (index: number | string) => string;
    circularReference: string;
    multilineMargin: string;
    number: (num: number) => string;
    string: (str: string) => string;
    symbol: (sym: Symbol) => string;
    boolean: (bool: boolean) => string;
    date: (date: Date) => string;
    regexp: (regexp: RegExp) => string;
    nul: string;
    undefined: string;
    arrayDepthExceeded: string;
    sizeExceededToken: string;
    unreoslvedGetter: string;
    emptyObject(ctor: Function): any;
    binary({name, size}: BinaryScalar): string;
    objectDepthExceeded(obj: object): string;
    textBlock({lines}: TextBlockScalar): string[];
}
export declare type YamprintTheme = {
    [K in keyof FormatSpecifier]?: (s: string) => string;
};
export declare class YamprintFormatter implements FormatSpecifier {
    private _formatCtorTag(line);
    emptyObject(ctor: Function): string;
    propertyKey(key: string): string;
    theme(theme: YamprintTheme): any;
    constructorTag(ctor: any): string;
    sparseArrayIndex(ix: number | string): string;
    function(f: Function): string;
    binary({name, size}: BinaryScalar): string;
    threwAlert(err: any): string;
    circularReference: string;
    emptyArray: string;
    arrayDepthExceeded: string;
    objectDepthExceeded(obj: Function): string;
    sizeExceededToken: string;
    arrayPrefix: string;
    indent: string;
    unreoslvedGetter: string;
    number(n: any): any;
    textBlock({lines}: TextBlockScalar): string[];
    multilineMargin: string;
    string(s: string): string;
    symbol(s: any): any;
    boolean(b: any): any;
    undefined: string;
    nul: string;
    date(d: any): any;
    regexp(r: any): any;
}
