import { YamprintFormatter, YamprintTheme } from "./yamprint-formatter";
import { GraphBuilderRules as YamprintRules } from "./graph-builder";
export { YamprintRules };
export interface Yamprinter {
    /**
     * Returns a string representation of the object using the default yamprinter.
     */
    (objToPrint: any): string;
}
export interface YamprintOptions {
    formatter?: YamprintFormatter | YamprintTheme;
    rules?: Partial<YamprintRules>;
}
export declare const yamprint: Yamprinter & {
    create(options?: YamprintOptions): Yamprinter;
    defaults: {
        rules: YamprintRules;
        formatter: YamprintFormatter;
    };
};
